/************************************************************************
 *   IRC - Internet Relay Chat, include/h.h
 *   Copyright (C) 1992 Darren Reed
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * "h.h". - Headers file.
 *
 * Most of the externs and prototypes thrown in here to 'cleanup' things.
 * -avalon
 */
#ifndef TRUE
#  define TRUE    1
#endif

#ifndef FALSE
#  define FALSE   0
#endif

extern time_t nextconnect, nextdnscheck, nextping;
extern aClient *client, me, *local[];
extern aClient *nsptr, *csptr, *msptr, *osptr;
extern aChannel *channel;
extern struct  stats   *ircstp;
extern int     bootopt;
/* Prototype added to force errors -- Barubary */
extern time_t  check_pings(time_t now, int check_kills);

extern int oper_closed;

/* Borg88
global comment for find_kill(void) find_zap(void) ...
*/
extern char gcomment[];

/* Remmed out for win32 compatability -- Matt J. Stanton (DalNerd)
 * #ifdef _WIN32
 * extern      void    *hCio;
 * #endif
 */

#define BREPORT_DO_DNS "NOTICE AUTH :*** Looking up your hostname...\r\n"
#define BREPORT_FIN_DNS "NOTICE AUTH :*** Found your hostname\r\n"
#define BREPORT_FIN_DNSC "NOTICE AUTH :*** Found your hostname (cached)\r\n"
#define BREPORT_FAIL_DNS "NOTICE AUTH :*** Couldn't resolve your hostname; using IP address instead\r\n"
#define BREPORT_DO_ID "NOTICE AUTH :*** Checking ident...\r\n"
#define BREPORT_FIN_ID "NOTICE AUTH :*** Received ident response\r\n"
#define BREPORT_FAIL_ID "NOTICE AUTH :*** No ident response; username prefixed with ~\r\n"

extern int R_do_dns, R_fin_dns, R_fin_dnsc, R_fail_dns, R_do_id, R_fin_id, R_fail_id;
extern char REPORT_DO_DNS[128], REPORT_FIN_DNS[128], REPORT_FIN_DNSC[128],
	REPORT_FAIL_DNS[128], REPORT_DO_ID[128], REPORT_FIN_ID[128],
	REPORT_FAIL_ID[128];

extern aChannel *find_channel (char *, aChannel *);
extern void    remove_user_from_channel (aClient *, aChannel *);
extern void    del_invite (aClient *, aChannel *);
extern int     del_silence (aClient *, char *);
extern void    send_user_joins (aClient *, aClient *);
extern void    clean_channelname (char *);
extern int     do_nick_name (char *);
extern const char *can_send (aClient *, aChannel *, const char *);
extern int     is_chan_op (aClient *, aChannel *);
extern int     is_zombie (aClient *, aChannel *);
extern int     has_op (aClient *, aChannel *);
extern int     has_voice (aClient *, aChannel *);
extern int     count_channels (aClient *);

extern Ban *is_banned (aClient *, aChannel *, int);

extern aClient *find_client (char *, aClient *);
extern aClient *find_name (char *, aClient *);
extern aClient *find_person (char *, aClient *);
extern aClient *find_server (char *, aClient *);
extern aClient *find_service (char *, aClient *);

extern int     attach_conf (aClient *, aConfItem *);
extern aConfItem *attach_confs (aClient*, char *, int);
extern aConfItem *attach_confs_host (aClient*, char *, int);
extern int     attach_Iline (aClient *, struct hostent *, char *);
extern aConfItem *conf, *find_me (void), *find_admin (void);
extern aConfItem *count_cnlines (Link *);
extern  aSqlineItem *sqline;
extern void    det_confs_butmask (aClient *, int);
extern int     detach_conf (aClient *, aConfItem *);
extern  aSqlineItem *find_sqline_nick (char *);
extern aSqlineItem *find_sqline_match (char *);
extern aConfItem *det_confs_butone (aClient *, aConfItem *);
extern  char *find_diepass(void);
extern  char *find_restartpass(void);
extern aConfItem *find_vhost (char *ip);
extern void make_vhost (aConfItem *tmp,char *ip,char *dptr);
extern aConfItem *find_conf (Link *, char*, int);
extern aConfItem *find_conf_exact (char *, char *, char *, int);
extern aConfItem *find_conf_host (Link *, char *, int);
extern aConfItem *find_conf_name (char *, int);
extern  aConfItem *find_temp_conf_entry (aConfItem *, u_int);
extern  aConfItem *find_conf_servern (char *);
extern int     find_kill (aClient *);
extern char    find_zap (aClient *);
extern int     find_restrict (aClient *);
extern int     rehash (aClient *, aClient *, int);
extern int     initconf (int);
extern void    add_temp_conf(unsigned int, char *, char *, char *, int, int, int);
extern void    inittoken (void);
extern void    reset_help (void);

extern char    *debugmode, *configfile, *debugfn, *sbrk0;
extern void    get_sockhost (aClient *, char *);
extern char    *rpl_str (int), *err_str (int);
extern int     dgets (int, char *, int);
extern char    *inetntoa (char *);
extern int dbufalloc, dbufblocks, debuglevel;
#ifndef _WIN32
extern int errno, h_errno;
extern char *strerror(int);
#endif
extern int     highest_fd, debuglevel, portnum, debugtty, maxusersperchannel;
extern int     readcalls, udpfd, resfd;
extern aClient *add_connection (aClient *, int);
extern int     add_listener (aConfItem *);
extern void    add_local_domain (char *, int);
extern int     check_client (aClient *);
extern int     check_server (aClient *, struct hostent *, aConfItem *, aConfItem *, int);
extern int     check_server_init (aClient *);
extern void    close_connection (aClient *);
extern void    close_listeners (void);
extern int connect_server (aConfItem *, aClient *, struct hostent *);
extern void    get_my_name (aClient *, char *, int);
extern int     get_sockerr (aClient *);
extern int     inetport (aClient *, char *, int);
extern void    init_sys (void);
extern int     read_message (time_t);
extern void    report_error (char *, aClient *);
extern void    set_non_blocking (int, aClient *);
extern int     setup_ping (void);
extern int     utmp_open (void);
extern int     utmp_read (int, char *, char *, char *, int);
extern int     utmp_close (int);

extern void    start_auth (aClient *);
extern void    read_authports (aClient *);
extern void    send_authports (aClient *);

extern void    restart (char *);
extern void    send_channel_modes (aClient *, aChannel *);
extern void    server_restart (char *);
extern void    terminate (void);
extern void write_pidfile(void), kill_pidfile(void);

extern void server_restart(char *);

extern int     writecalls, writeb[];
extern int     deliver_it (aClient *, char *, int);

extern int     check_registered (aClient *);
extern int     check_registered_user (aClient *);
extern char    *get_client_name (aClient *, int);
extern char    *get_client_host (aClient *);
extern char    *my_name_for_link (char *, aConfItem *);
extern char    *myctime (time_t), *date (time_t);
extern char * my_timestamp(void);
extern int     exit_client (aClient *, aClient *, aClient *, char *);
extern void    initstats (void), tstats (aClient *, char *);
extern void    vstats (aClient *,char *);
extern char    *check_string (char *);
extern void hmask_update(aClient *);

extern char *make_nick_user_host (char *, char *, char *);
extern void make_nick_user_hosts(aClient *, char *, char *);

extern int     parse (aClient *, char *, char *, struct Message *);
extern int     do_numeric (int, aClient *, aClient *, int, char **);
extern int hunt_server (aClient *,aClient *,char *,int,int,char **);
extern aClient *next_client (aClient *, char *);

extern int     m_umode (aClient *, aClient *, int, char **);
extern int     m_names (aClient *, aClient *, int, char **);
extern int     m_server_estab (aClient *);
extern void    send_umode (aClient *, aClient *, int, int, char *);
extern void    send_umode_out (aClient*, aClient *, int);

extern void    free_client (aClient *);
extern void    free_link (Link *);
extern void    free_ban (Ban *);
extern void    free_conf (aConfItem *);
extern void    free_class (aClass *);
extern void    free_user (anUser *, aClient *);
extern int     find_str_match_link (Link **, char *);
extern void    free_str_list PROTO ((Link *));
extern Link    *make_link (void);
extern Ban     *make_ban (void);
extern anUser  *make_user (aClient *);
extern  aSqlineItem *make_sqline (void);
extern aConfItem *make_conf (void);
extern aClass  *make_class (void);
extern aServer *make_server (aClient *);
extern aClient *make_client (aClient *, aClient *);
extern Link    *find_user_link (Link *, aClient *);
extern int     IsMember (aClient *, aChannel *);
extern char    *pretty_mask (char *);
extern void    add_client_to_list (aClient *);
extern void    checklist (void);
extern void    remove_client_from_list (aClient *);
extern void    initlists (void);

extern void    add_class (int, int, int, int, long);
extern void    fix_class (aConfItem *, aConfItem *);
extern u_long get_sendq (aClient *);
extern int     get_con_freq (aClass *);
extern int     get_client_ping (aClient *);
extern int     get_client_class (aClient *);
extern int     get_conf_class (aConfItem *);
extern void    report_classes (aClient *);

#ifndef _WIN32
extern struct hostent *get_res (char *);
#else
extern struct hostent *get_res (char *, long);
#endif
extern struct  hostent *gethost_byaddr (char *, Link *);
extern struct  hostent *gethost_byname (char *, Link *);
extern void    flush_cache (void);
extern int     init_resolver (int);
extern time_t  timeout_query_list (time_t);
extern time_t  expire_cache (time_t);
extern void    del_queries (char *);
extern char *canonize(char *);

extern void    clear_channel_hash_table (void);
extern void    clear_client_hash_table (void);
extern void    clear_notify_hash_table (void);
extern int     add_to_client_hash_table (char *, aClient *);
extern int     del_from_client_hash_table (char *, aClient *);
extern int     add_to_channel_hash_table (char *, aChannel *);
extern int     del_from_channel_hash_table (char *, aChannel *);
extern int     add_to_notify_hash_table (char *, aClient *);
extern int     del_from_notify_hash_table (char *, aClient *);
extern int     hash_check_notify (aClient *, int);
extern int     hash_del_notify_list (aClient  *);
extern void    count_watch_memory (int *, u_long *);
extern aNotify *hash_get_notify (char *);
extern aChannel *hash_get_chan_bucket (int);
extern aChannel *hash_find_channel (char *, aChannel *);
extern aClient *hash_find_client (char *, aClient *);
extern aClient *hash_find_server (char *, aClient *);

extern void add_history (aClient *);
extern aClient *get_history (char *, time_t);
extern void initwhowas (void);
extern void off_history (aClient *);

extern int dopacket (aClient *, char *, int);

extern void vdebug(int, char *, va_list);
extern void debug(int, char *, ...);
#if defined(DEBUGMODE)
extern void send_usage (aClient *, char *);
extern void send_listinfo (aClient *, char *);
extern void count_memory (aClient *, char *);
#endif
extern void server_terminate(char *, ...);

char *crule_parse (char *);
int crule_eval (char *);
void crule_free (char **);

extern char *collapse(char *);

extern void translate_message(char *, int, char);
extern unsigned int get_ticks(void);
extern char *get_default_umode(void);
extern const char *get_ircd_version(void);
extern void send_protoctl(aClient*);
