/* m_quit.c -- remove a client from the network by one's will;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 * $Id: m_quit.c,v 1.11 2002/11/18 12:44:08 hex Exp $
 */

#include <string.h>

#include "struct.h"
#include "msg.h"
#include "h.h"
#include "channel.h"

/* parv[0] = sender prefix, parv[1] = comment */
int m_quit(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	Link **lp;
	char *pparv[3], comment[TOPICLEN + 1];

	if (check_registered(sptr))
		return 0;

	if (!MyClient(sptr))
		return exit_client(cptr, sptr, sptr,
			BadPtr(parv[1]) ? "No reason" : parv[1]);

	pparv[0] = parv[0];

	strcpy(comment, "Quit: ");

	if (parc > 1 && !BadPtr(parv[1])) {
		strncpy(comment + 6, parv[1], TOPICLEN - 6);
		comment[TOPICLEN] = 0;
	}
	else strcat(comment, "Leaving");

	/* check if we need to part some channels */
	for (lp = &(sptr->user->channel); *lp; ) {
		pparv[1] = ((*lp)->value.chptr)->chname;

		if (can_send(cptr, (*lp)->value.chptr, comment) != 0) {
			m_part(cptr, sptr, 2, pparv);
			continue;
		}

		/* everything's okay, skip this channel */
		lp = &((*lp)->next);
	}

	return exit_client(cptr, sptr, sptr, comment);
}
