/* m_rehash.c -- update server configuration, reset some settings;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 * $Id: m_rehash.c,v 1.12 2002/11/18 12:44:08 hex Exp $
 */

#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"
#include "ircdlog.h"
#include "services.h"
#include "unicode.h"

/* added remote rehash, parv[1] - remote server -- Borg88 */
int m_rehash(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	if (check_registered(sptr))
		return 0;

	if (!IsAnOper(sptr)) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return(0);
	}

	if (parc > 1) {
		if (!IsOper(sptr)) {
			sendto_one(sptr, err_str(ERR_NOPRIVILEGES),
				me.name, parv[0]);
			return 0;
		}

		if (hunt_server(cptr, sptr, ":%s REHASH %s", 1, parc, parv)
			!= HUNTED_ISME) return 0;
	}

	sendto_one(sptr, rpl_str(RPL_REHASHING), me.name, parv[0], configfile);
	sendto_ops("%s is rehashing Server config file", parv[0]);

	/* remove unused conversion tables */
	charset_refresh();

	/* check if we need to locate any services */
	if ((!BadPtr(ns_nick) && nsptr == NULL)
	|| (!BadPtr(cs_nick) && csptr == NULL)
	|| (!BadPtr(ms_nick) && msptr == NULL)
	|| (!BadPtr(os_nick) && osptr == NULL)) {
		aClient *acptr, *next;
		for (acptr = client; acptr; acptr = next) {
			next = acptr->next;
			if (IsClient(acptr) && (acptr->flags & FLAGS_ULINE))
				ircd_catch_service(acptr);
		}
	}

	/* lose services if don't need some */
	if (nsptr != NULL && BadPtr(ns_nick))
		nsptr = NULL;
	if (csptr != NULL && BadPtr(cs_nick))
		csptr = NULL;
	if (msptr != NULL && BadPtr(ms_nick))
		msptr = NULL;
	if (osptr != NULL && BadPtr(os_nick))
		osptr = NULL;

	putlog(LOG_INFO, "REHASH from %s", get_client_name(sptr, FALSE));

	return rehash(cptr, sptr, (parc > 1) ? ((*parv[1] == 'q') ? 2 : 0) : 0);
}
