/* m_ungline.c -- remove a K-Line on all servers;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 * $Id: m_ungline.c,v 1.10 2002/11/18 12:44:08 hex Exp $
 */

#include <string.h>

#include "struct.h"
#include "numeric.h"
#include "msg.h"
#include "h.h"
#include "send.h"

extern int del_temp_conf(unsigned int, char *, char *, char *,
	int, int class, unsigned int);

int m_ungline(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	char *hosttemp, host[128], name[128];

	if (check_registered(sptr))
		return 0;

	if (MyClient(sptr) && !IsOper(sptr)) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	}

	if (parc < 2) {
		send_syntax(sptr, MSG_UNGLINE, "UNGLINE user@host");
		return 0;
	}

	if (strlen(parv[1]) > 127) {
		sendto_one(sptr, "NOTICE %s :Bad parameters", parv[0]);
		return 0;
	}

	if (!(hosttemp = strchr(parv[1], '@'))) {
		sendto_one(sptr,"NOTICE %s :Both user and host fields must be "
			"non-null", parv[0]);
		return 0;
	}

	memset(name, 0, sizeof(name));
	strcpy(host, ++hosttemp);
	strncpy(name, parv[1], hosttemp - 1 - parv[1]);

	if (name[0] =='\0' || host[0]=='\0') {
		sendto_one(sptr, "NOTICE %s :Both user and host fields must be "
			"non-null", parv[0]);
		return 0;
	}

	if (del_temp_conf(CONF_KILL, host, NULL, name, 0, 0, 0) == 1) {
		if (MyClient(sptr))
			sendto_one(sptr, "NOTICE %s :Temp K-Line %s@%s is now "
				"removed.", parv[0], name, host);
		sendto_ops("%s removed temp K-Line %s@%s", parv[0], name, host);
	}

	sendto_serv_butone((IsServer(cptr)) ? cptr : 0, ":%s UNGLINE %s",
		parv[0], parv[1]);

	return 0;
}
