/* strerror.c -- an emulation for the libraries that miss it;
 * Copyright (c) 2001-2002 ForestNet IRC Network;
 * This is a free software; see file `license' for details.
 */

#ifdef NEED_strerror

#include <stdio.h>
#ifdef _WIN32
# include <windows.h>
#endif

char* strerror(int err_no)
{
	extern char *sys_errlist[];  /* Sigh... hopefully on all systems */
	extern int sys_nerr;

	static char buff[40];
	char *errp;

	errp = (err_no > sys_nerr ? NULL : sys_errlist[err_no]);

	if (errp == NULL) {
#ifndef _WIN32
		snprintf(buff, sizeof(buff), "Unknown Error %d", err_no);
#else
		switch (err_no) {
			case WSAECONNRESET:
				snprintf(buff, sizeof(buff), "Connection reset by peer");
				break;
			default:
				snprintf(buff, sizeof(buff), "Unknown Error %d", err_no);
				break;
		}
#endif

		buff[sizeof(buff)-1] = '\0';
		errp = buff;
	}

	return errp;
}
#endif /* NEED_strerror */

